package org.netkernel.scheduler;

import org.netkernel.request.IExpiry;
import org.netkernel.request.IRequest;
import org.netkernel.request.IResponse;
import org.netkernel.request.IResponseMeta;

public class AdditionalDependencyState implements IRequestState
{
	private final IInternalResponseMeta mMeta;
	
	public AdditionalDependencyState(IResponse aResponse)
	{	//response forced to not effect scope, also cost is rolled up as an efficiency
		IResponseMeta m=aResponse.getMeta();
		int cost;
		int scope= Integer.MAX_VALUE;
		IExpiry[] expDeterminants;
		if (m instanceof IInternalResponseMeta)
		{	IInternalResponseMeta m2=(IInternalResponseMeta)m;
			cost=m2.getTotalCost();
			expDeterminants=m2.getExpiryDeterminants();
			if (aResponse.getRepresentation()==null)
			{	// special side effect
				scope = Math.min(m2.getUnresolvedScope(),m2.getResolvedScope());
			}
		}
		else
		{	cost=0;
			expDeterminants=new IExpiry[] {m.getExpiry()};
		}
		mMeta=new InternalResponseMeta(m.getExpiry(),m.getUserMetaData(),scope,scope,cost,cost,IInternalResponseMeta.NONE,0,expDeterminants);
	}

	public void declareSubrequestIssue(IRequestState substate)
	{
	}

	public void declareSubrequestResponse(IRequestState substate)
	{
	}

	public IRequest getRequestIn()
	{	return null;
	}

	public RootState getRoot()
	{
		return null;
	}

	public void resumeTimer()
	{
	}

	public boolean isComplete()
	{	return true;
	}

	public IInternalResponseMeta getResponseMeta()
	{	return mMeta;
	}
	
	public IRequestState getParent()
	{	return null;
	}	

}
