package org.netkernel.scheduler;

import java.util.concurrent.atomic.AtomicLong;

import org.netkernel.request.IRequest;

public class RootState extends RequestState
{
	private final Scheduler mScheduler;
	private final IRequest mRootRequest;
	private final long mId;
	
	private static AtomicLong sId = new AtomicLong();
	
	public RootState(Scheduler aScheduler, IRequest aRequestIn, IRequest aRootRequest)
	{	super(aScheduler.getGroundState(),aRequestIn);
		mRootRequest=aRootRequest;
		mRoot=this;
		mScheduler=aScheduler;
		mId=sId.getAndIncrement();
	}
	
	public RootState getRoot()
	{	return this;
	}
	
	public IRequest getRootRequest()
	{	return mRootRequest;
	}
	
	public Scheduler getScheduler()
	{	return mScheduler;
	}
	
	public long getId()
	{	return mId;
	}
	
	public IRequestState getParent()
	{	return null;
	}
	
	public static long getNextId()
	{	return sId.get();
	}
}
