/******************************************************************************
  (c) Copyright 2002-2008, 1060 Research Ltd                                   

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      
 *****************************************************************************/
package org.netkernel.urii;

/** Abstract subclass of ClassLoader which adds necessary interface to work with NetKernel
 * @author Tony Butterfield
 *
 */
public abstract class ClassLoaderWithExports extends ClassLoader
{
	public ClassLoaderWithExports()
	{	super();
	}
	
	public ClassLoaderWithExports(ClassLoader aParent)
	{	super(aParent);
	}
	
	/** Check to see if this this classloader declares it can load the given class name
	 * for another classloader
	 * @param aName the name of the class to check
	 * @return true if it can load the class
	 */
	public abstract boolean exports(String aName);
	
	/** Check to see if this classloader and hence all the classes it has loaded are to be
	 * declared invalid
	 * @return true if classloader is declared invalid
	 */
	public abstract boolean isInvalidated();
	
	/** Returns true if one or more classes are exported
	 */
	public abstract boolean hasExports();
	
	/** Attempt to load a class from THIS classloader with delegating to any parent
	 * @param aName
	 * @return
	 * @throws ClassNotFoundException
	 */
	@SuppressWarnings("unchecked")
	public abstract Class loadClassAvoidingParent(String aName) throws ClassNotFoundException;
	
	/** Return parent classloader
	 * @return
	 */
	public abstract ClassLoader getParentClassLoader();
}
